=== debian/control ===
Source: rock-master-20.01-simulation-mars-gui
Section: science
Priority: extra
Maintainer: Rock Packaging Daemon (based on apaka) <rock-dev@dfki.de>
Build-Depends: cdbs, debhelper (>= 8.0.0), pkg-config, dh-autoreconf, cmake, libopencv-dev, libqt4-dev, qt4-qmake, rock-master-20.01-simulation-lib-manager, rock-master-20.01-simulation-mars-common-data-broker, rock-master-20.01-simulation-mars-common-gui-main-gui, rock-master-20.01-simulation-mars-common-utils, rock-master-20.01-simulation-mars-interfaces
Standards-Version: 3.9.2
Homepage: http://www.rock-robotics.org

Package: rock-master-20.01-simulation-mars-gui
Architecture: any
Depends: ${shlibs:Depends}, rock-master-20.01-simulation-lib-manager, rock-master-20.01-simulation-mars-common-data-broker, rock-master-20.01-simulation-mars-common-gui-main-gui, rock-master-20.01-simulation-mars-common-utils, rock-master-20.01-simulation-mars-interfaces, cmake, libopencv-dev, libqt4-dev, qt4-qmake
Description: mars_gui
 DFKI Robot simulator GUI
